package com.sun.xml.internal.ws.policy;

import java.util.Iterator;
import java.util.Arrays;

public final class NestedPolicy extends Policy
{
    private static final String NESTED_POLICY_TOSTRING_NAME = "nested policy";
    
    private NestedPolicy(AssertionSet set) {
        super("nested policy", Arrays.asList(new AssertionSet[] { set }));
    }
    
    private NestedPolicy(String name, String policyId, AssertionSet set) {
        super("nested policy", name, policyId, Arrays.asList(new AssertionSet[] { set }));
    }
    
    static NestedPolicy createNestedPolicy(AssertionSet set) {
        return new NestedPolicy(set);
    }
    
    static NestedPolicy createNestedPolicy(String name, String policyId, AssertionSet set) {
        return new NestedPolicy(name, policyId, set);
    }
    
    public AssertionSet getAssertionSet() {
        Iterator<AssertionSet> iterator = this.iterator();
        if (iterator.hasNext()) {
            return (AssertionSet)iterator.next();
        }
        return null;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (!(obj instanceof NestedPolicy)) {
            return false;
        }
        NestedPolicy that = (NestedPolicy)obj;
        return super.equals(that);
    }
    
    @Override
    public int hashCode() {
        return super.hashCode();
    }
    
    @Override
    public String toString() {
        return this.toString(0, new StringBuffer()).toString();
    }
    
    @Override
    StringBuffer toString(int indentLevel, StringBuffer buffer) {
        return super.toString(indentLevel, buffer);
    }
}
